<template>
  <div>Sortieren: <button class="sortBibliographyButton" id="sortBibliographyButtonAuthor" @click="sortBibliographyByName">Autor*in / Herausgeber*in</button> <button class="sortBibliographyButton" id="sortBibliographyButtonDate" @click="sortBibliographyByYear">Jahr</button></div>
  <div id="bibliography">
    <!--
      Apparently, Vue's `@load` event is not always fired when the iframe is loaded;
      the following code does not work as expected:
      
      <iframe src="/bibliography.html" @load="initializeBibliography"/>

      So we use the plain `onload` event instead:
    -->
    <iframe src="/bibliography.html" onload="this.parentElement.innerHTML = this.contentDocument.getElementsByTagName('body')[0].innerHTML; document.getElementById('sortBibliographyButtonDate').click(); document.getElementById('sortBibliographyButtonAuthor').click()"/>
  </div>
</template>

<script>
function compareBibliographyEntries(a, b, selector){
  var fieldA = selectBibliographyField(a, selector);
  var fieldB = selectBibliographyField(b, selector);
  return fieldA.localeCompare(fieldB);
}

function selectBibliographyField(entry, selector){
  var fields = entry.querySelectorAll(selector);
  return (fields.length > 0 ? fields[0].innerHTML.trim() : "");
}

function sortBibliography(selector) {
  var bibliography = document.getElementById("bibliography");
  var entryList = bibliography.getElementsByTagName("ul")[0];
  entryList.innerHTML = Array.from(entryList.children).sort((a, b) => compareBibliographyEntries(a, b, selector)).map(entry => entry.outerHTML).join("");
}

export default {
  methods: {
    initializeBibliography: function() {
      var bibliography = document.getElementById("bibliography");
      var iframe = bibliography.getElementsByTagName("iframe")[0];
      bibliography.innerHTML = iframe.contentDocument.getElementsByTagName("body")[0].innerHTML;
      sortBibliography(".date");
      sortBibliography(".author,.editor");
    },
    sortBibliographyByName: function() {
      sortBibliography(".author,.editor");
    },
    sortBibliographyByYear: function() {
      sortBibliography(".date");
    }
  }
};
</script>

<style lang="scss" scoped>
@import "../styles/components/bibliography.scss";
</style>
